#!/bin/sh

#
# loftstory.sh - Affiche les dernieres nouvelles du loft
# (http://loftstory.fr).
#

#
# URL des nouvelles.
#

URL_LOFT="http://loftstory.m6.fr/site/accueil/accueil.htm"
URL_LOFT="http://loftstory.m6.fr/site/news1/newslist.htm"

#
# Fichier contenant les nouvelles chargees.
#

#FIC_LOFT=/tmp/loftstory.`date "+%d-%m-%Y.%H-H-%M-MN-%S-S"`
FIC_LOFT=/tmp/loftstory.$$

[ $# -eq 1 ] && MaxCarParLigne=$1 || MaxCarParLigne=60

cd `dirname $0`

wget -q --cache=off "$URL_LOFT" -O $FIC_LOFT

#
# Le fichier HTML est recode en Latin1.
#

#recode UTF-8..lat1 $FIC_LOFT

Nb=0
while [ $Nb -lt `expr $MaxCarParLigne / 2 - 1` ]
do
    Separateur="$Separateur-="
    Nb=`expr $Nb + 1`
done

Separateur="$Separateur-"

echo -e ` \
iconv -f utf8 -t latin1 $FIC_LOFT | \
tr -d '\015' | \
grep -v "<\!\-\-.*\-\->" |  \
grep -iv "<script.*>.*<\/script>" | \
grep -iv "<title>" | \
(while read ligne
do

#
# Zapper les commentaires HTML :
#   <!-- Commentaire HTML
#        sur plusieurs lignes
#   -->
#

    if echo "$ligne" | grep "<\!\-\-" > /dev/null
    then
        while read ligne
        do
            echo "$ligne" | grep "\-\->" > /dev/null && break
        done
        ligne=""
    fi

#
# Zapper les scripts (JavaScript et autres) :
#   <script language=...
#       commandes...
#   </script>
#

    if echo "$ligne" | grep -i "<script" > /dev/null
    then
        while read ligne
        do
            echo "$ligne" | grep -i "<\/script>" | grep -iv "<script" > /dev/null && break
        done
        ligne=""
    fi

#
# Zapper les baliser HTML :
#   <balise>...</balise>
#

    echo "$ligne" | sed -e "s/<[^>]*>//g" -e "s/\&[^\;]*\;//g"
done) | \
sed -e "s;\([0-9][0-9]*/[0-9][0-9]*\)\([A-Z][A-Z]*\);\\\\\n\\\\\n$Separateur\\\\\n\\\\\n\\\\\n>-*- \1 -*-<\\\\\n\\\\\n\2;g" \
    -e "s;\([0-9][0-9]*:[0-9][0-9]*\);(\1)\\\\\n\\\\\n;g"` | \
sed -e "s;[A-Z ]*[0-9]*/[A-Z][A-Z]*.*;;" \
    -e "s/[0-9][0-9]*\.[0-9][0-9]*% *//g" \
    -e "s/\([.!?]\)\([a-zA-Z]\)/\1 \2/g" | \
./indent.sh $MaxCarParLigne | \
uniq #> $FIC_LOFT.tmp

rm -f $FIC_LOFT
#cat $FIC_LOFT.tmp

exit 0
